picom/bin/compton-trans

169 lines
3.9 KiB
Plaintext
Raw Normal View History

#!/bin/sh
2011-12-07 18:35:22 +00:00
#
# compton-trans
2011-12-07 18:35:22 +00:00
# transset in a bash script
2012-04-01 04:54:42 +00:00
# Copyright (c) 2011-2012, Christopher Jeffrey
#
2011-12-07 18:35:22 +00:00
2012-04-01 04:54:42 +00:00
# Usage:
2013-05-04 19:29:10 +00:00
# $ compton-trans [options] [+|-]opacity
# By window id
# $ compton-trans -w "$WINDOWID" 75
# By name
# $ compton-trans -n "urxvt" 75
# By current window
# $ compton-trans -c 75
# By selection
# $ compton-trans 75
# $ compton-trans -s 75
# Increment current window 5%
# $ compton-trans -c +5
2011-12-07 18:35:22 +00:00
# "command" is a shell built-in, faster than "which"
if test -z "$(command -v xprop)" -o -z "$(command -v xwininfo)"; then
2013-05-04 18:34:34 +00:00
echo 'Please install x11-utils/xorg-xprop/xorg-xwininfo.' >& 2
2011-12-21 19:28:55 +00:00
exit 1
fi
2011-12-07 18:35:22 +00:00
# Variables
args=
arg=
2013-05-04 19:29:10 +00:00
active=
wprefix=
2011-12-07 18:35:22 +00:00
window=
opacity=
cur=
2013-05-04 21:37:52 +00:00
action=
treeout=
wid=
topmost=
lineno=
2011-12-07 18:35:22 +00:00
# Workaround: replace '-5' with '~5' so as not to confuse getopts.
for v in "$@"; do
shift && set -- "$@" "$(echo "$v" | sed 's/^-\([0-9]\+%\?\)$/~\1/')"
done
# Use getopt to parse arguments.
args=$(getopt -o 'scdgn:w:o:' -l 'select,current,delete,get,name:,window:,opacity:' -- "$@")
if test $? -ne 0; then
echo 'Bad arguments.'
exit 1
fi
2013-05-04 19:29:10 +00:00
eval set -- "$args"
2013-05-04 19:29:10 +00:00
while test $# -gt 0; do
arg=$1
shift
case "$arg" in
--) break ;;
-s | --select) wprefix=''; window='' ;;
-c | --current)
active=$(xprop -root -notype _NET_ACTIVE_WINDOW \
| sed 's/^.*\(0x\S*\).*$/\1/')
wprefix='-id'; window=$active
;;
-d | --delete) action='delete' ;;
-g | --get) action='get' ;;
-n | --name) wprefix='-name'; window=$1; shift ;;
-w | --window) wprefix='-id'; window=$1; shift ;;
-o | --opacity) opacity=$1; shift ;;
esac
2011-12-07 18:35:22 +00:00
done
test -n "$1" && opacity=$1
2011-12-07 18:35:22 +00:00
2013-05-04 18:34:34 +00:00
# clean up opacity. xargs == a poor man's trim.
opacity=$(echo "$opacity" | xargs | sed 's/%//g' | sed 's/^~\([0-9]\+\)$/-\1/')
# Validate opacity value
2013-05-04 21:37:52 +00:00
if test -z "$action" && ! echo "$opacity" | grep -q '^[+-]\?[0-9]\+$'; then
2013-05-04 19:29:10 +00:00
echo "Invalid opacity specified: $opacity."
exit 1
fi
# Get ID of the target window
if test -z "$wprefix"; then
treeout=$(xwininfo -children -frame)
else
treeout=$(xwininfo -children $wprefix "$window")
fi
wid=$(echo "$treeout" | sed -n 's/^xwininfo:.*: \(0x[[:xdigit:]]*\).*$/\1/p')
if test -z "$wid"; then
2013-05-04 18:34:34 +00:00
echo 'Failed to find window.'
exit 1
fi
# Make sure it's not root window
if echo "$treeout" | fgrep -q 'Parent window id: 0x0'; then
2013-05-04 18:34:34 +00:00
echo 'Cannot set opacity on root window.'
exit 1
fi
# If it's already the topmost window
if echo "$treeout" | grep -q 'Parent window id: 0x[[:xdigit:]]* (the root window)'; then
topmost=$wid
else
# Get the whole window tree
treeout=$(xwininfo -root -tree)
if test -z "$treeout"; then
2013-05-04 18:34:34 +00:00
echo 'Failed to get root window tree.'
2012-04-01 04:54:42 +00:00
exit 1
fi
# Find the line number of the target window in the window tree
lineno=$(echo -n "$treeout" | grep -nw "$wid" | head -n1 | cut -d ':' -f 1)
2011-12-07 18:35:22 +00:00
if test -z "$lineno"; then
2013-05-04 18:34:34 +00:00
echo 'Failed to find window in window tree.'
exit 1
fi
2011-12-07 18:35:22 +00:00
# Find the highest ancestor of the target window below
topmost=$(echo -n "$treeout" \
2013-05-04 21:54:18 +00:00
| head -n $((lineno + 1)) \
2013-05-04 18:34:34 +00:00
| sed -n 's/^ \(0x[[:xdigit:]]*\).*/\1/p' \
| tail -n 1)
fi
if test -z "$topmost"; then
2013-05-04 18:34:34 +00:00
echo 'Failed to find the highest parent window below root of the' \
'selected window.'
exit 1
fi
# Remove the opacity property.
2013-05-04 21:37:52 +00:00
if test x"$action" = x'delete'; then
xprop -id "$topmost" -remove _NET_WM_WINDOW_OPACITY
exit 0
fi
2013-05-04 21:37:52 +00:00
# Get current opacity.
cur=$(xprop -id "$topmost" -notype _NET_WM_WINDOW_OPACITY \
| sed 's/^.*\b\([0-9]\+\).*$\|^.*$/\1/')
test -z "$cur" && cur=0xffffffff
cur=$((cur * 100 / 0xffffffff))
# Output current opacity.
if test x"$action" = x'get'; then
echo "$cur"
exit 0
fi
# Calculate the desired opacity
if echo "$opacity" | grep -q '^[+-]'; then
opacity=$(($cur + $opacity))
2011-12-07 18:35:22 +00:00
fi
test $opacity -lt 0 && opacity=0
test $opacity -gt 100 && opacity=100
# Set opacity
opacity=$((opacity * 0xffffffff / 100))
xprop -id "$topmost" -f _NET_WM_WINDOW_OPACITY 32c \
-set _NET_WM_WINDOW_OPACITY "$opacity"